config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  # Almost every application defines a route for the root path ("/") at the top of this file.
  root 'home#index'
  post '/search', to: 'home#search'
  get '/clear_message', to: 'home#clear_message'

  resources :posts do
    resources :likes, only: %i[create destroy]
    resources :comments, only: %i[new create destroy]
  end

  get '/login', to: 'session#index', as: 'new_session'
  post '/login', to: 'session#create'
  delete '/logout', to: 'session#destroy', as: 'destroy_session'

  get '/register', to: 'registration#index', as: 'new_registration'
  post '/register', to: 'registration#create'
end

app/controllers/home_controller.rb
# frozen_string_literal: true

# class HomeController
class HomeController < ApplicationController
  def index; end

  def search
    @posts = []
    @count = 0

    if params[:q].present?
      @pagy, @posts = pagy(Post.search(params[:q]), page: 1)
      @count = @posts.count
    end

    respond_to do |format|
      format.turbo_stream
    end
  end
end

app/helpers/home_helper.rb
# frozen_string_literal: true

# module  HomeHelper
module HomeHelper
  STATUS = {
    success: 'px-4 py-3 leading-normal text-blue-700 border border-blue-500 rounded-lg',
    error: 'px-4 py-3 leading-normal text-red-700 border border-red-500 rounded-lg',
    info: 'px-4 py-3 leading-normal text-gren-700 border border-green-500 rounded-lg'
  }.freeze

  def notice_stream(message:, status:)
    turbo_stream.append :notice, partial: 'shared/notice', locals: { notice: message, status: STATUS[status] }
  end
end

app/views/home/index.html.erb
<div class="bg-white border shadow-md rounded-md pb-12 w-4/3 mx-auto px-4 min-h-screen">
  <div class="w-full flex flex-wrap border-b shadow-b">
    <div class="lg:w-1/4 sm:w-full xl:w-full  text-center lg:text-4xl text-gray-400 p-4 md:text-2xl sm:text-md">Pesquisar</div>
    <div class="lg:w-3/4 sm:w-full xl:w-full text-center self-center">
      <%= form_tag('/search', method: :post, data: { controller: 'search', action: 'turbo:submit-end->search#perform' }) do %>
        <%= text_field_tag :q, nil, 
          class: 'lg:w-full md:w-full sm:w-full xs:w-full p-3 lg:text-3xl border rounded-md md:text-lg sm:text-md',
          placeholder: 'Pesquise por titulo, autor ou tag'
        %>
      <% end %>
    </div>
  </div>

  <%= turbo_frame_tag 'title' do %>
    <h1 class="text-center text-4xl text-gray-500 p-3 mt-4">Blog - Últimos Posts </h1>
  <% end %>

  <%= turbo_stream_from :posts %>
  
  <%= turbo_frame_tag :posts, src: posts_path, loading: :lazy do %>
    <h1 class="text-center text-4xl text-gray-500 p-3 mt-4">Blog - Últimos Posts </h1>
    
    <% 3.times do %>
      <%= render partial: 'shared/loading' %>
    <% end %>
  <% end %>
</div>

app/views/home/search.turbo_stream.erb
<% if @posts.present? %>
  <%= notice_stream(message: 'Pesquisa realizada com sucesso', status: :success) %>
<% else %>
  <%= notice_stream(message: 'Pesquisa realizada, nada foi encontrado !', status: :info) %>
<% end %>

<%= turbo_stream.replace 'title' do %>
  <%= turbo_frame_tag :title do %>
    <%= "<h1 class='text-4xl text-gray-500 p-3 mt-4'>Resultado(s): #{@count} encontrado(s).</h1>".html_safe %>
  <% end %>
<% end %>

<%= turbo_stream.replace :posts do %>
  <%= turbo_frame_tag :posts do %>
    <%= render partial: 'posts/post', collection: @posts, as: :post %>
  <% end %>
<% end %>
      